  int pulses, A_SIG=0, B_SIG=1;
  unsigned long previousMillis=0;
  int interval=1000;
  double speed=0;
  double voltage=0;

void setup() {
  //setter opp avbrudd og input på 
  //portene fra Rotasjonsomformeren
  pinMode(40, INPUT);
  pinMode(41, INPUT);
  attachInterrupt(40, A_RISE, RISING);
  Serial.begin(115200);

  analogWriteResolution(12);
}

void loop() {
  //sett spenning og regn ut farten hvert sekund
  voltage = Voltage(speed);
  analogWrite(DAC1, voltage ); 
  
  //sjekker om det har gått et sekund, 
  //dersom ja, regn ut fart og nullstill pulsvariabel
  unsigned long currentMillis = millis();
  if ((unsigned long)(currentMillis - previousMillis) >= interval) {
    speed=SPEED(pulses);
    pulses=0;
    previousMillis=currentMillis;
 }
  
}
//avbruddsrutinen, ved avbrudd sjekkes B-signalet
//for å avgjøre fartsretning og pulsvariabelen øker/minker
void A_RISE(){
 A_SIG=1;
 B_SIG=digitalRead(41);
 if(B_SIG==0)
 pulses++;//moving forward
 if(B_SIG==1)
 pulses--;//moving reverse
 }

//Metode som tar inn antall pulser og returnerer fart
double SPEED(double Pulses){
	double V=0;
	V=(Pulses/10000)*5.236;
	return V;
}

//Metode som tar inn farten og 
//regner ut hvilken spenning som skal settes ut
double Voltage(double speed){
  double S=0;
  double V=0;
  S = speed + 12;
  V = S * 170,666666667;
  
  if(S == 12)
  V = 2048;
  
  if(S <= 0)
  V = 0;
  
  if(S >= 24)
  V = 4096;
  
  return V;
}
